diff -r f40675df5d4c trytond/modules/account/move.py
--- a/trytond/modules/account/move.py	Fri Sep 21 15:57:18 2012 +0200
+++ b/trytond/modules/account/move.py	Mon Sep 24 20:36:38 2012 +0200
@@ -708,102 +693,96 @@
                                 and - line_amount or Decimal('0.0')
                     if 'account' in fields:
                         values['account'] = account_id
-                        values['account.rec_name'] = account_obj.browse(
-                                account_id).rec_name
+                        values['account.rec_name'] = Account(
+                            account_id).rec_name
                     if 'tax_lines' in fields and code_id:
                         values['tax_lines'] = [
                             {
                                 'amount': tax_amount,
                                 'currency_digits': line.currency_digits,
                                 'code': code_id,
-                                'code.rec_name': tax_code_obj.browse(
-                                    code_id).rec_name,
+                                'code.rec_name': TaxCode(code_id).rec_name,
                                 'tax': tax_id,
-                                'tax.rec_name': tax_obj.browse(tax_id).rec_name
+                                'tax.rec_name': Tax(tax_id).rec_name,
                             },
                         ]
         return values
 
-    def get_currency_digits(self, ids, names):
-        res = {}
-        for line in self.browse(ids):
+    @classmethod
+    def get_currency_digits(cls, lines, names):
+        digits = {}
+        for line in lines:
             for name in names:
-                res.setdefault(name, {})
-                res[name].setdefault(line.id, 2)
+                digits.setdefault(name, {})
+                digits[name].setdefault(line.id, 2)
                 if name == 'currency_digits':
-                    res[name][line.id] = line.account.currency_digits
+                    digits[name][line.id] = line.account.currency_digits
                 elif name == 'second_currency_digits':
                     second_currency = line.account.second_currency
                     if second_currency:
-                        res[name][line.id] = second_currency.digits
-        return res
+                        digits[name][line.id] = second_currency.digits
+        return digits
 
-    def on_change_debit(self, vals):
-        res = {}
-        journal_obj = Pool().get('account.journal')
-        if vals.get('journal') or Transaction().context.get('journal'):
-            journal = journal_obj.browse(vals.get('journal')
-                    or Transaction().context.get('journal'))
+    def on_change_debit(self):
+        changes = {}
+        Journal = Pool().get('account.journal')
+        if self.journal or Transaction().context.get('journal'):
+            journal = self.journal or Journal(Transaction().context['journal'])
             if journal.type in ('expense', 'revenue'):
-                res['tax_lines'] = self._compute_tax_lines(vals, journal.type)
-                if not res['tax_lines']:
-                    del res['tax_lines']
-        if vals.get('debit'):
-            res['credit'] = Decimal('0.0')
-        return res
+                changes['tax_lines'] = self._compute_tax_lines(journal.type)
+                if not changes['tax_lines']:
+                    del changes['tax_lines']
+        if self.debit:
+            changes['credit'] = Decimal('0.0')
+        return changes
 
-    def on_change_credit(self, vals):
-        res = {}
-        journal_obj = Pool().get('account.journal')
-        if vals.get('journal') or Transaction().context.get('journal'):
-            journal = journal_obj.browse(vals.get('journal')
-                    or Transaction().context.get('journal'))
+    def on_change_credit(self):
+        changes = {}
+        Journal = Pool().get('account.journal')
+        if self.journal or Transaction().context.get('journal'):
+            journal = self.journal or Journal(Transaction().context['journal'])
             if journal.type in ('expense', 'revenue'):
-                res['tax_lines'] = self._compute_tax_lines(
-                        vals, journal.type)
-                if not res['tax_lines']:
-                    del res['tax_lines']
-        if vals.get('credit'):
-            res['debit'] = Decimal('0.0')
-        return res
+                changes['tax_lines'] = self._compute_tax_lines(journal.type)
+                if not changes['tax_lines']:
+                    del changes['tax_lines']
+        if self.credit:
+            changes['debit'] = Decimal('0.0')
+        return changes
 
-    def on_change_account(self, vals):
-        account_obj = Pool().get('account.account')
-        journal_obj = Pool().get('account.journal')
+    def on_change_account(self):
+        Journal = Pool().get('account.journal')
 
-        res = {}
+        changes = {}
         if Transaction().context.get('journal'):
-            journal = journal_obj.browse(Transaction().context['journal'])
+            journal = Journal(Transaction().context['journal'])
             if journal.type in ('expense', 'revenue'):
-                res['tax_lines'] = self._compute_tax_lines(vals, journal.type)
-                if not res['tax_lines']:
-                    del res['tax_lines']
+                changes['tax_lines'] = self._compute_tax_lines(journal.type)
+                if not changes['tax_lines']:
+                    del changes['tax_lines']
 
-        if vals.get('account'):
-            account = account_obj.browse(vals['account'])
-            res['currency_digits'] = account.currency_digits
-            if account.second_currency:
-                res['second_currency_digits'] = account.second_currency.digits
-        return res
+        if self.account:
+            changes['currency_digits'] = self.account.currency_digits
+            if self.account.second_currency:
+                changes['second_currency_digits'] = \
+                    self.account.second_currency.digits
+        return changes
 
-    def _compute_tax_lines(self, vals, journal_type):
+    def _compute_tax_lines(self, journal_type):
         res = {}
         pool = Pool()
-        account_obj = pool.get('account.account')
-        tax_code_obj = pool.get('account.tax.code')
-        tax_obj = pool.get('account.tax')
-        tax_line_obj = pool.get('account.tax.line')
+        TaxCode = pool.get('account.tax.code')
+        Tax = pool.get('account.tax')
+        TaxLine = pool.get('account.tax.line')
 
-        if vals.get('move'):
+        if self.move:
             #Only for first line
             return res
-        if vals.get('tax_lines'):
-            res['remove'] = [x['id'] for x in vals['tax_lines']]
-        if vals.get('account'):
-            account = account_obj.browse(vals['account'])
-            debit = vals.get('debit', Decimal('0.0'))
-            credit = vals.get('credit', Decimal('0.0'))
-            for tax in account.taxes:
+        if self.tax_lines:
+            res['remove'] = [x['id'] for x in self.tax_lines]
+        if self.account:
+            debit = self.debit or Decimal('0.0')
+            credit = self.credit or  Decimal('0.0')
+            for tax in self.account.taxes:
                 if journal_type == 'revenue':
                     if debit:
                         key = 'credit_note'
@@ -815,8 +794,7 @@
                     else:
                         key = 'credit_note'
                 base_amounts = {}
-                for tax_line in tax_obj.compute(
-                        [x.id for x in account.taxes],
+                for tax_line in Tax.compute(self.account.taxes,
                         debit or credit, 1):
                     code_id = tax_line['tax'][key + '_base_code'].id
                     if not code_id:
@@ -828,37 +806,32 @@
                 for code_id, tax_id in base_amounts:
                     if not base_amounts[code_id, tax_id]:
                         continue
-                    value = tax_line_obj.default_get(
-                        tax_line_obj._columns.keys())
+                    value = TaxLine.default_get(TaxLine._fields.keys())
                     value.update({
                             'amount': base_amounts[code_id, tax_id],
-                            'currency_digits': account.currency_digits,
+                            'currency_digits': self.account.currency_digits,
                             'code': code_id,
-                            'code.rec_name': tax_code_obj.browse(
-                                code_id).rec_name,
+                            'code.rec_name': TaxCode(code_id).rec_name,
                             'tax': tax_id,
-                            'tax.rec_name': tax_obj.browse(tax_id).rec_name,
+                            'tax.rec_name': Tax(tax_id).rec_name,
                             })
                     res.setdefault('add', []).append(value)
         return res
 
-    def on_change_party(self, vals):
-        pool = Pool()
-        party_obj = pool.get('party.party')
-        journal_obj = pool.get('account.journal')
-        currency_obj = pool.get('currency.currency')
+    def on_change_party(self):
+        Journal = Pool().get('account.journal')
         cursor = Transaction().cursor
         res = {}
-        if (not vals.get('party')) or vals.get('account'):
-            return res
-        party = party_obj.browse(vals.get('party'))
-
-        if not party.account_receivable \
-                or not party.account_payable:
+        if (not self.party) or self.account:
             return res
 
-        if party and (not vals.get('debit')) and (not vals.get('credit')):
-            type_name = FIELDS[self.debit._type].sql_type(self.debit)[0]
+        if not self.party.account_receivable \
+                or not self.party.account_payable:
+            return res
+
+        if self.party and (not self.debit) and (not self.credit):
+            type_name = FIELDS[self.__class__.debit._type].sql_type(
+                self.__class__.debit)[0]
             query = 'SELECT ' \
                         'CAST(COALESCE(SUM(' \
                             '(COALESCE(debit, 0) - COALESCE(credit, 0))' \
@@ -867,122 +840,126 @@
                     'WHERE reconciliation IS NULL ' \
                         'AND party = %s ' \
                         'AND account = %s'
-            cursor.execute(query, (party.id, party.account_receivable.id))
+            cursor.execute(query,
+                (self.party.id, self.party.account_receivable.id))
             amount = cursor.fetchone()[0]
             # SQLite uses float for SUM
             if not isinstance(amount, Decimal):
                 amount = Decimal(str(amount))
-            if not currency_obj.is_zero(party.account_receivable.currency,
-                    amount):
+            if not self.party.account_receivable.currency.is_zero(amount):
                 if amount > Decimal('0.0'):
-                    res['credit'] = currency_obj.round(
-                            party.account_receivable.currency, amount)
+                    res['credit'] = \
+                        self.party.account_receivable.currency.round(amount)
                     res['debit'] = Decimal('0.0')
                 else:
                     res['credit'] = Decimal('0.0')
-                    res['debit'] = - currency_obj.round(
-                            party.account_receivable.currency, amount)
-                res['account'] = party.account_receivable.id
-                res['account.rec_name'] = party.account_receivable.rec_name
+                    res['debit'] = \
+                        - self.party.account_receivable.currency.round(amount)
+                res['account'] = self.party.account_receivable.id
+                res['account.rec_name'] = \
+                    self.party.account_receivable.rec_name
             else:
-                cursor.execute(query, (party.id, party.account_payable.id))
+                cursor.execute(query,
+                    (self.party.id, self.party.account_payable.id))
                 amount = cursor.fetchone()[0]
-                if not currency_obj.is_zero(party.account_payable.currency,
-                        amount):
+                if not self.party.account_payable.currency.is_zero(amount):
                     if amount > Decimal('0.0'):
-                        res['credit'] = currency_obj.round(
-                                party.account_payable.currency, amount)
+                        res['credit'] = \
+                            self.party.account_payable.currency.round(amount)
                         res['debit'] = Decimal('0.0')
                     else:
                         res['credit'] = Decimal('0.0')
-                        res['debit'] = - currency_obj.round(
-                                party.account_payable.currency, amount)
-                    res['account'] = party.account_payable.id
-                    res['account.rec_name'] = party.account_payable.rec_name
+                        res['debit'] = \
+                            - self.party.account_payable.currency.round(amount)
+                    res['account'] = self.party.account_payable.id
+                    res['account.rec_name'] = \
+                        self.party.account_payable.rec_name
 
-        if party and vals.get('debit'):
-            if vals['debit'] > Decimal('0.0'):
+        if self.party and self.debit:
+            if self.debit > Decimal('0.0'):
                 if 'account' not in res:
-                    res['account'] = party.account_receivable.id
-                    res['account.rec_name'] = party.account_receivable.rec_name
+                    res['account'] = self.party.account_receivable.id
+                    res['account.rec_name'] = \
+                        self.party.account_receivable.rec_name
             else:
                 if 'account' not in res:
-                    res['account'] = party.account_payable.id
-                    res['account.rec_name'] = party.account_payable.rec_name
+                    res['account'] = self.party.account_payable.id
+                    res['account.rec_name'] = \
+                        self.party.account_payable.rec_name
 
-        if party and vals.get('credit'):
-            if vals['credit'] > Decimal('0.0'):
+        if self.party and self.credit:
+            if self.credit > Decimal('0.0'):
                 if 'account' not in res:
-                    res['account'] = party.account_payable.id
-                    res['account.rec_name'] = party.account_payable.rec_name
+                    res['account'] = self.party.account_payable.id
+                    res['account.rec_name'] = \
+                        self.party.account_payable.rec_name
             else:
                 if 'account' not in res:
-                    res['account'] = party.account_receivable.id
-                    res['account.rec_name'] = party.account_receivable.rec_name
+                    res['account'] = self.party.account_receivable.id
+                    res['account.rec_name'] = \
+                        self.party.account_receivable.rec_name
 
-        journal_id = (vals.get('journal')
-                or Transaction().context.get('journal'))
-        if journal_id and party:
-            journal = journal_obj.browse(journal_id)
+        journal = (self.journal
+                or Journal(Transaction().context.get('journal')))
+        if journal and self.party:
             if journal.type == 'revenue':
                 if 'account' not in res:
-                    res['account'] = party.account_receivable.id
-                    res['account.rec_name'] = party.account_receivable.rec_name
+                    res['account'] = self.party.account_receivable.id
+                    res['account.rec_name'] = \
+                        self.party.account_receivable.rec_name
             elif journal.type == 'expense':
                 if 'account' not in res:
-                    res['account'] = party.account_payable.id
-                    res['account.rec_name'] = party.account_payable.rec_name
+                    res['account'] = self.party.account_payable.id
+                    res['account.rec_name'] = \
+                        self.party.account_payable.rec_name
         return res
 
-    def get_move_field(self, ids, name):
+    def get_move_field(self, name):
         if name == 'move_state':
             name = 'state'
         if name not in ('period', 'journal', 'date', 'state'):
             raise Exception('Invalid name')
-        res = {}
-        for line in self.browse(ids):
-            if name in ('date', 'state'):
-                res[line.id] = line.move[name]
-            else:
-                res[line.id] = line.move[name].id
-        return res
+        if name in ('date', 'state'):
+            return getattr(self.move, name)
+        else:
+            return getattr(self.move, name).id
 
-    def set_move_field(self, ids, name, value):
+    @classmethod
+    def set_move_field(cls, lines, name, value):
         if name == 'move_state':
             name = 'state'
         if name not in ('period', 'journal', 'date', 'state'):
             raise Exception('Invalid name')
         if not value:
             return
-        move_obj = Pool().get('account.move')
-        lines = self.browse(ids)
-        move_obj.write([line.move.id for line in lines], {
-            name: value,
-            })
+        Move = Pool().get('account.move')
+        Move.write([line.move for line in lines], {
+                name: value,
+                })
 
-    def search_move_field(self, name, clause):
+    @classmethod
+    def search_move_field(cls, name, clause):
         if name == 'move_state':
             name = 'state'
         return [('move.' + name,) + tuple(clause[1:])]
 
-    def query_get(self, obj='l'):
+    @classmethod
+    def query_get(cls, obj='l'):
         '''
         Return SQL clause and fiscal years for account move line
         depending of the context.
-
-        :param obj: the SQL alias of account_move_line in the query
-        :return: a tuple with the SQL clause and the fiscalyear ids
+        obj is the SQL alias of account_move_line in the query
         '''
-        fiscalyear_obj = Pool().get('account.fiscalyear')
+        FiscalYear = Pool().get('account.fiscalyear')
 
         if Transaction().context.get('date'):
             time.strptime(str(Transaction().context['date']), '%Y-%m-%d')
-            fiscalyear_ids = fiscalyear_obj.search([
-                ('start_date', '<=', Transaction().context['date']),
-                ('end_date', '>=', Transaction().context['date']),
-                ], limit=1)
+            fiscalyears = FiscalYear.search([
+                    ('start_date', '<=', Transaction().context['date']),
+                    ('end_date', '>=', Transaction().context['date']),
+                    ], limit=1)
 
-            fiscalyear_id = fiscalyear_ids and fiscalyear_ids[0] or 0
+            fiscalyear_id = fiscalyears and fiscalyears[0].id or 0
 
             if Transaction().context.get('posted'):
                 return (obj + '.active ' \
@@ -997,7 +974,7 @@
                                         str(Transaction().context['date']) + \
                                         '\') ' \
                                     'AND m.state = \'posted\' ' \
-                            ')', fiscalyear_ids)
+                            ')', [f.id for f in fiscalyears])
             else:
                 return (obj + '.active ' \
                         'AND ' + obj + '.state != \'draft\' ' \
@@ -1010,7 +987,7 @@
                                     'AND m.date <= date(\'' + \
                                         str(Transaction().context['date']) + \
                                         '\')' \
-                            ')', fiscalyear_ids)
+                            ')', [f.id for f in fiscalyears])
 
         if Transaction().context.get('periods'):
             if Transaction().context.get('fiscalyear'):
@@ -1036,10 +1013,12 @@
                         ')', fiscalyear_ids)
         else:
             if not Transaction().context.get('fiscalyear'):
-                fiscalyear_ids = fiscalyear_obj.search([
+                fiscalyears = FiscalYear.search([
                     ('state', '=', 'open'),
                     ])
-                fiscalyear_clause = (','.join(map(str, fiscalyear_ids))) or '0'
+                fiscalyear_ids = [f.id for f in fiscalyears]
+                fiscalyear_clause = (','.join(
+                        str(f.id) for f in fiscalyears)) or '0'
             else:
                 fiscalyear_ids = [int(Transaction().context.get('fiscalyear'))]
                 fiscalyear_clause = '%s' % int(
@@ -1067,159 +1046,146 @@
                             ')'
                         ')', fiscalyear_ids)
 
-    def on_write(self, ids):
-        lines = self.browse(ids)
-        res = []
-        for line in lines:
-            res.extend([x.id for x in line.move.lines])
-        return list({}.fromkeys(res))
+    @classmethod
+    def on_write(cls, lines):
+        return list(set(l.id for line in lines for l in line.move.lines))
 
-    def check_account(self, ids):
-        for line in self.browse(ids):
-            if line.account.kind in ('view',):
-                return False
-            if not line.account.active:
-                return False
+    def check_account(self):
+        if self.account.kind in ('view',):
+            return False
+        if not self.account.active:
+            return False
         return True
 
-    def check_journal_period_modify(self, period_id, journal_id):
+    @classmethod
+    def check_journal_period_modify(cls, period, journal):
         '''
         Check if the lines can be modified or created for the journal - period
         and if there is no journal - period, create it
         '''
-        pool = Pool()
-        journal_period_obj = pool.get('account.journal.period')
-        journal_obj = pool.get('account.journal')
-        period_obj = pool.get('account.period')
-        journal_period_ids = journal_period_obj.search([
-            ('journal', '=', journal_id),
-            ('period', '=', period_id),
-            ], limit=1)
-        if journal_period_ids:
-            journal_period = journal_period_obj.browse(journal_period_ids[0])
+        JournalPeriod = Pool().get('account.journal.period')
+        journal_periods = JournalPeriod.search([
+                ('journal', '=', journal.id),
+                ('period', '=', period.id),
+                ], limit=1)
+        if journal_periods:
+            journal_period, = journal_periods
             if journal_period.state == 'close':
-                self.raise_user_error('add_modify_closed_journal_period')
+                cls.raise_user_error('add_modify_closed_journal_period')
         else:
-            journal = journal_obj.browse(journal_id)
-            period = period_obj.browse(period_id)
-            journal_period_obj.create({
-                'name': journal.name + ' - ' + period.name,
-                'journal': journal.id,
-                'period': period.id,
-                })
-        return
+            JournalPeriod.create({
+                    'name': journal.name + ' - ' + period.name,
+                    'journal': journal.id,
+                    'period': period.id,
+                    })
 
-    def check_modify(self, ids):
+    @classmethod
+    def check_modify(cls, lines):
         '''
         Check if the lines can be modified
         '''
         journal_period_done = []
-        for line in self.browse(ids):
+        for line in lines:
             if line.move.state == 'posted':
-                self.raise_user_error('modify_posted_move')
+                cls.raise_user_error('modify_posted_move')
             if line.reconciliation:
-                self.raise_user_error('modify_reconciled')
+                cls.raise_user_error('modify_reconciled')
             journal_period = (line.journal.id, line.period.id)
             if journal_period not in journal_period_done:
-                self.check_journal_period_modify(line.period.id,
-                        line.journal.id)
+                cls.check_journal_period_modify(line.period,
+                        line.journal)
                 journal_period_done.append(journal_period)
-        return
 
-    def delete(self, ids):
-        move_obj = Pool().get('account.move')
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-        self.check_modify(ids)
-        lines = self.browse(ids)
-        move_ids = [x.move.id for x in lines]
-        res = super(Line, self).delete(ids)
-        move_obj.validate(move_ids)
-        return res
+    @classmethod
+    def delete(cls, lines):
+        Move = Pool().get('account.move')
+        cls.check_modify(lines)
+        moves = [x.move for x in lines]
+        super(Line, cls).delete(lines)
+        Move.validate(moves)
 
-    def write(self, ids, vals):
-        move_obj = Pool().get('account.move')
-
-        if isinstance(ids, (int, long)):
-            ids = [ids]
+    @classmethod
+    def write(cls, lines, vals):
+        Move = Pool().get('account.move')
 
         if len(vals) > 1 or 'reconciliation' not in vals:
-            self.check_modify(ids)
-        lines = self.browse(ids)
-        move_ids = [x.move.id for x in lines]
-        res = super(Line, self).write(ids, vals)
+            cls.check_modify(lines)
+        moves = [x.move for x in lines]
+        super(Line, cls).write(lines, vals)
 
         Transaction().timestamp = {}
 
-        lines = self.browse(ids)
         for line in lines:
-            if line.move.id not in move_ids:
-                move_ids.append(line.move.id)
-        move_obj.validate(move_ids)
-        return res
+            if line.move not in moves:
+                moves.append(line.move)
+        Move.validate(moves)
 
-    def create(self, vals):
-        journal_obj = Pool().get('account.journal')
-        move_obj = Pool().get('account.move')
+    @classmethod
+    def create(cls, vals):
+        pool = Pool()
+        Journal = pool.get('account.journal')
+        Move = pool.get('account.move')
         vals = vals.copy()
         if not vals.get('move'):
             journal_id = (vals.get('journal')
                     or Transaction().context.get('journal'))
             if not journal_id:
-                self.raise_user_error('no_journal')
-            journal = journal_obj.browse(journal_id)
+                cls.raise_user_error('no_journal')
+            journal = Journal(journal_id)
             if journal.centralised:
-                move_ids = move_obj.search([
-                    ('period', '=', vals.get('period')
-                        or Transaction().context.get('period')),
-                    ('journal', '=', journal_id),
-                    ('state', '!=', 'posted'),
-                    ], limit=1)
-                if move_ids:
-                    vals['move'] = move_ids[0]
+                moves = Move.search([
+                        ('period', '=', vals.get('period')
+                            or Transaction().context.get('period')),
+                        ('journal', '=', journal_id),
+                        ('state', '!=', 'posted'),
+                        ], limit=1)
+                if moves:
+                    vals['move'] = moves[0].id
             if not vals.get('move'):
-                vals['move'] = move_obj.create({
-                    'period': (vals.get('period')
-                        or Transaction().context.get('period')),
-                    'journal': journal_id,
-                    'date': vals.get('date'),
-                    })
-        res = super(Line, self).create(vals)
-        line = self.browse(res)
-        self.check_journal_period_modify(line.period.id, line.journal.id)
-        move_obj.validate([vals['move']])
-        return res
+                vals['move'] = Move.create({
+                        'period': (vals.get('period')
+                            or Transaction().context.get('period')),
+                        'journal': journal_id,
+                        'date': vals.get('date'),
+                        }).id
+        line = super(Line, cls).create(vals)
+        cls.check_journal_period_modify(line.period, line.journal)
+        Move.validate([line.move])
+        return line
 
-    def copy(self, ids, default=None):
+    @classmethod
+    def copy(cls, lines, default=None):
         if default is None:
             default = {}
         if 'move' not in default:
             default['move'] = None
         if 'reconciliation' not in default:
             default['reconciliation'] = None
-        return super(Line, self).copy(ids, default=default)
+        return super(Line, cls).copy(lines, default=default)
 
-    def view_header_get(self, value, view_type='form'):
-        journal_period_obj = Pool().get('account.journal.period')
+    @classmethod
+    def view_header_get(cls, value, view_type='form'):
+        JournalPeriod = Pool().get('account.journal.period')
         if (not Transaction().context.get('journal')
                 or not Transaction().context.get('period')):
             return value
-        journal_period_ids = journal_period_obj.search([
-            ('journal', '=', Transaction().context['journal']),
-            ('period', '=', Transaction().context['period']),
-            ], limit=1)
-        if not journal_period_ids:
+        journal_periods = JournalPeriod.search([
+                ('journal', '=', Transaction().context['journal']),
+                ('period', '=', Transaction().context['period']),
+                ], limit=1)
+        if not journal_periods:
             return value
-        journal_period = journal_period_obj.browse(journal_period_ids[0])
+        journal_period, = journal_periods
         return value + ': ' + journal_period.rec_name
 
-    def fields_view_get(self, view_id=None, view_type='form'):
-        journal_obj = Pool().get('account.journal')
-        result = super(Line, self).fields_view_get(view_id=view_id,
+    @classmethod
+    def fields_view_get(cls, view_id=None, view_type='form'):
+        Journal = Pool().get('account.journal')
+        result = super(Line, cls).fields_view_get(view_id=view_id,
             view_type=view_type)
         if view_type == 'tree' and 'journal' in Transaction().context:
-            title = self.view_header_get('', view_type=view_type)
-            journal = journal_obj.browse(Transaction().context['journal'])
+            title = cls.view_header_get('', view_type=view_type)
+            journal = Journal(Transaction().context['journal'])
 
             if not journal.view:
                 return result
